﻿using System;
using System.Windows.Forms;
using System.Net;
using System.IO;
using System.Net.Sockets;
using System.Threading;
using System.Runtime.InteropServices;

namespace WFRCS
{
    public partial class Form1 : Form
    {
        private StreamWriter swSender;
        private StreamReader srReceiver;
        private TcpClient tcpServer;
        private Thread thrMessaging;
        private bool Connected;

        Server mainServer;
        string _IPs; int _Ports;

        [DllImport("AutoItX3.dll", EntryPoint = "AU3_MouseClick")]
        public static extern int MouseClick(string button, int positionX, int positionY, int NumOfClics, int nSpeed);

        [DllImport("AutoItX3.dll", EntryPoint = "AU3_MouseMove")]
        public static extern int MouseMove(int positionX, int positionY, int NumOfClics, int nSpeed);

        [DllImport("AutoItX3.dll", EntryPoint = "AU3_MouseWheel")]
        public static extern int MouseWheel(string direction, int nSpeed);

        [DllImport("AutoItX3.dll", EntryPoint = "AU3_MouseGetPosX")]
        public static extern int MouseGetPosX();

        [DllImport("AutoItX3.dll", EntryPoint = "AU3_MouseGetPosY")]
        public static extern int MouseGetPosY();

        public Form1()
        {
            InitializeComponent();
        }


        #region Client
        public void OnApplicationExit(object sender, EventArgs e)
        {
            if (Connected == true)
            {
                Connected = false;
                swSender.Close();
                srReceiver.Close();
                tcpServer.Close();
            }
        }

        private void ReceiveMessages()
        {
            srReceiver = new StreamReader(tcpServer.GetStream());
            while (Connected)
            {
                try
                {
                    string _msg = srReceiver.ReadLine();
                    string[] temp = new string[2];
                    temp = _msg.Split(':');
                    try
                    {
                        if (temp[1] == "lmouse")
                        {
                            int x, y;
                            x = MouseGetPosX();
                            y = MouseGetPosY();
                            MouseClick("left", x, y, 1, 1);
                        }
                        if (temp[1] == "2lmouse")
                        {
                            int x, y;
                            x = MouseGetPosX();
                            y = MouseGetPosY(); 
                            MouseClick("left", x, y, 2, 1);
                        }
                        if (temp[1] == "rmouse")
                        {
                            int x, y;
                            x = MouseGetPosX();
                            y = MouseGetPosY(); 
                            MouseClick("right", x, y, 1, 1);
                        }
                        if (temp[1] == "smouse")
                        {
                            int x, y;
                            x = MouseGetPosX();
                            y = MouseGetPosY(); 
                            MouseClick("middle", x, y, 1, 1);
                        }
                        if (temp[1] == "upmouse")
                        {
                            int x, y;
                            x = MouseGetPosX();
                            y = MouseGetPosY(); y -= 10;
                            MouseMove(x, y, 0, 1);
                        }
                        if (temp[1] == "downmouse")
                        {
                            int x, y;
                            x = MouseGetPosX();
                            y = MouseGetPosY(); y += 10;
                            MouseMove(x, y, 0, 1);
                        }
                        if (temp[1] == "leftmouse")
                        {
                            int x, y;
                            x = MouseGetPosX(); x -= 10;
                            y = MouseGetPosY(); 
                            MouseMove(x, y, 0, 1);
                        }
                        if (temp[1] == "rightmouse")
                        {
                            int x, y;
                            x = MouseGetPosX(); x += 10;
                            y = MouseGetPosY(); 
                            MouseMove(x, y, 0, 1);
                        }
                        if (temp[1] == "upscrollmouse")
                        {
                            MouseWheel("up",10);
                        }
                        if (temp[1] == "downscrollmouse")
                        {
                            MouseWheel("down", 10);
                        }
                    }
                    catch (Exception)
                    {
                    }
                }
                catch (IOException)
                {
                    //MessageBox.Show("Соединение было разорвано!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    //btnDisconnect_Click(this, new EventArgs());
                }
            }
        }

        private void SendMessage(string Msg)
        {
            swSender.WriteLine(Msg);
            swSender.Flush();
        }
        #endregion


        private void startToolStripMenuItem_Click(object sender, EventArgs e)
        {
            _IPs = textBox2.Text;
            _Ports = int.Parse(textBox3.Text);
            IPAddress _IP = IPAddress.Parse(_IPs);
            int _port = _Ports;
            int _users = 10;

            mainServer = new Server(_IP, _port, _users);
            Server.StatusChanged += new StatusChangedEventHandler(mainServer_StatusChanged);
            mainServer.StartListening();
            //textBox1.AppendText("Сервер стартовал с параметрами: \nIP: " + _IP + " \nPort: " + _port + "\nUsers: " + _users + "\n");
            //textBox1.AppendText("|");

            string IP = _IPs; int Port = _Ports;
            tcpServer = new TcpClient();
            try
            {
                tcpServer.Connect(IPAddress.Parse(IP), Port);

                Connected = true;

                swSender = new StreamWriter(tcpServer.GetStream());
                thrMessaging = new Thread(new ThreadStart(ReceiveMessages));
                thrMessaging.Start();
                startToolStripMenuItem.Enabled = false;
            }
            catch
            {
                //textBox1.AppendText("Соединение не установлено.");
                //textBox1.AppendText("|");
                startToolStripMenuItem.Enabled = true;
            }
            SendMessage("WFRCS");
        }

        delegate void aptexDelegate(string text);

        void aptex(string text)
        {
            textBox1.AppendText(text);
            textBox1.AppendText("|");
        }

        public void mainServer_StatusChanged(object sender, StatusChangedEventArgs e)
        {
            /*if (textBox1.InvokeRequired)
            {
                aptexDelegate aptexdel =
                new aptexDelegate(aptex);
                textBox1.Invoke(aptexdel, e.EventMessage);

            }*/
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Connected == true)
            {
                OnApplicationExit(sender, e);
                thrMessaging.Abort();
                mainServer.Stop();
            }
            try
            {
                mainServer.Stop();
            }
            catch (Exception)
            {
            }
            Application.Exit();
        }

        private void notifyIcon1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                if (WindowState == FormWindowState.Normal)
                {
                    WindowState = FormWindowState.Minimized;
                    Hide();
                }
                else
                {
                    Show();
                    WindowState = FormWindowState.Normal;
                }
            }
        }

        private void Form1_Resize(object sender, EventArgs e)
        {
            if (FormWindowState.Minimized == WindowState)
            {
                Hide();
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string fileName = @"option.txt";
            FileStream stream = new FileStream(fileName, FileMode.Create, FileAccess.Write);
            if (stream != null)
            {
                StreamWriter writer = new StreamWriter(stream);
                writer.WriteLine(textBox2.Text);
                writer.WriteLine(textBox3.Text);
                writer.Flush();
                writer.Close();
                stream.Close();
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            string fileName = @"option.txt";
            FileStream stream = new FileStream(fileName, FileMode.OpenOrCreate, FileAccess.Read);
            if (fileName != "")
            {
                StreamReader reader = new StreamReader(stream);
                textBox2.Text = reader.ReadLine();
                textBox3.Text = reader.ReadLine();
                _IPs = textBox2.Text;
                _Ports = int.Parse(textBox3.Text);
                reader.Close();
                stream.Close();
            }
        }
    }
}
